# -*- coding: utf-8 -*-
#------------------------------------------------------------
# pelisalacarta - XBMC Plugin
# Canal para cinehanwer
# http://blog.tvalacarta.info/plugin-xbmc/pelisalacarta/
#------------------------------------------------------------

import urlparse, re
import sys

from core import logger
from core import scrapertools
from core.item import Item
from servers import servertools

__category__ = "A"
__type__ = "generic"
__title__ = "cinehanwer"
__channel__ = "cinehanwer"
__language__ = "ES"
__creationdate__ = "20140615"

host = "http://cinehanwer.com"

def isGeneric():
    return True

def mainlist( item ):
    logger.info( "pelisalacarta.channels.cinehanwer mainlist" )

    itemlist = []

    itemlist.append( Item( channel=__channel__, action="search", title="Buscar..." ) )
    itemlist.append( Item( channel=__channel__, action="peliculas", title="Novedades", url=host ) )
    itemlist.append( Item( channel=__channel__, action="peliculas", title="Estrenos", url=host + "/estrenos/" ) )
    itemlist.append( Item( channel=__channel__, action="peliculas", title="Más Vistas", url=host + "/inc/php/masvistas.php" ) )
    itemlist.append( Item( channel=__channel__, action="peliculas", title="Más Votadas", url=host + "/inc/php/masvotadas.php" ) )
    itemlist.append( Item( channel=__channel__, action="letras", title="A-Z" ) )
    itemlist.append( Item( channel=__channel__, action="calidades", title="Por Calidad", url=host ) )
    itemlist.append( Item( channel=__channel__, action="generos", title="Por Género", url=host ) )
    itemlist.append( Item( channel=__channel__, action="years", title="Por Años", url=host ) )

    return itemlist

def search( item, texto ):
    logger.info( "pelisalacarta.channels.cinehanwer search" )

    item.url = host + "/buscar/?q=" + texto

    try:
        return peliculas( item )
    # Se captura la excepción, para no interrumpir al buscador global si un canal falla
    except:
        import sys
        for line in sys.exc_info():
            logger.error( "%s" % line )
        return []

def peliculas( item ):
    logger.info( "pelisalacarta.channels.cinehanwer peliculas" )

    itemlist = []

    # Descarga la pagina
    data = agrupa_datos( scrapertools.cache_page( item.url ) )

    # Extrae las entradas
    patron  = '<a href="([^"]+)" title="([^"]+)"[^<]+'
    patron += '<img style="[^"]+" src="([^"]+)"[^<]+'
    patron += '<cite>(.*?)</cite>'

    matches = re.compile( patron, re.DOTALL ).findall( data )

    for scrapedurl, scrapedtitle, scrapedthumbnail, scrapedplot in matches:
        url = urlparse.urljoin( item.url, scrapedurl )
        title = scrapedtitle
        thumbnail = urlparse.urljoin( item.url, scrapedthumbnail )
        plot = re.sub( r'<center>|</center>|<span[^>]+>|</span>|', '', scrapedplot )
        plot = plot.replace( '<strong>', '\n', ).replace( '</strong>', ' ' ).replace( ' :', ':' )

        n_year = scrapertools.get_match( plot, 'Año: ([^\n]+)\n' )
        calidad = scrapertools.get_match( plot, 'Calidad: ([^\n]+)\n' )
        idiomas = scrapertools.get_match( plot, 'Idiomas: ([^$]+)$' )
        genero = scrapertools.get_match( plot, 'Genero: ([^\n]+)\n' )

        title+= ' (' + n_year + ') [' + calidad + '] [' + idiomas + '] [' + genero + ']'

        itemlist.append( Item( channel=__channel__, action="findvideos", title=title, url=url, thumbnail=thumbnail, plot=plot, fulltitle=title ) )

    next_page = scrapertools.find_single_match( data, '</b></span></a></li[^<]+<li><a href="([^"]+)">' )
    if next_page!="":
        itemlist.append( Item( channel=__channel__, action="peliculas", title=">> Página siguiente", url=urlparse.urljoin( item.url, next_page ) ) )

    return itemlist

def letras( item ):
    logger.info(" pelisalacarta.channels.cinehanwer letras" )

    itemlist = []

    az = "#ABCDEFGHIJKLMNOPQRSTUVWXYZ"

    for letra in az:
        url = host + "/letra/%s.html" % letra.lower().replace( '#', '09' )
        letra = letra.replace( '#', '0-9' )
        itemlist.append( Item( channel=__channel__, action='completo', title=letra, url=url, extra="peliculas" ) )

    return itemlist

def calidades( item ):
    logger.info( "pelisalacarta.channels.cinehanwer calidades" )

    itemlist = []

    # Descarga la pagina
    data = agrupa_datos( scrapertools.cache_page( item.url ) )
    data = scrapertools.find_single_match(data,'<div class="titc[^>]+>Buscar por C(.*?)</ul>')

    # Extrae las entradas (carpetas)
    patron  = '<li><a title="[^"]+" href="([^"]+)"><strong>([^<]+)</strong></a></li>'
    matches = re.compile(patron,re.DOTALL).findall(data)

    for scrapedurl, scrapedtitle in matches:
        title = scrapedtitle
        thumbnail = ""
        plot = ""
        url = urlparse.urljoin( item.url, scrapedurl )

        itemlist.append( Item( channel=__channel__, action="peliculas", title=title, url=url, thumbnail=thumbnail, plot=plot, fulltitle=title ) )

    return itemlist

def generos( item ):
    logger.info( "pelisalacarta.channels.cinehanwer generos" )

    itemlist = []

    # Descarga la pagina
    data = agrupa_datos( scrapertools.cache_page( item.url ) )
    data = scrapertools.find_single_match( data, '<div class="titc[^>]+>Buscar por G(.*?)</ul>' )

    # Extrae las entradas (carpetas)
    patron  = '<li><a href="([^"]+)"[^>]+>([^<]+)</a></li>'
    matches = re.compile( patron, re.DOTALL ).findall( data )

    for scrapedurl, scrapedtitle in matches:
        title = scrapedtitle
        thumbnail = ""
        plot = ""
        url = urlparse.urljoin( item.url, scrapedurl )

        itemlist.append( Item( channel=__channel__, action="peliculas", title=title, url=url, thumbnail=thumbnail, plot=plot, fulltitle=title ) )

    return itemlist

def years( item ):
    logger.info(" pelisalacarta.channels.cinehanwer years" )

    itemlist = []

    r_years = [ "2015", "2014", "2013", "2012", "2011", "2010",
                "2009-2005", "2004-2000", "1999-1995", "1994-1990",
                "1989-1980", "1979-1970", "1969-1960", "1959-1950", "1949-1940", "1939-1930" ]

    for r_year in r_years:
        url = host + "/year/%s/" % r_year
        itemlist.append( Item( channel=item.channel, action='s_years', title=r_year ) )

    return itemlist

def s_years( item ):
    logger.info(" pelisalacarta.channels.cinehanwer s_years" )

    itemlist = []

    if "-" in item.title:
        i_year = int( item.title.split( '-' )[0] )
        e_year = int( item.title.split( '-' )[1] )
    else:
        i_year = int( item.title )
        e_year = int( item.title )

    for n_year in range( i_year, e_year - 1, -1 ):

        item.channel = __channel__
        item.action = "completo"
        item.title = n_year
        item.url = host + "/year/%s/" % n_year
        item.extra = "peliculas"

        itemlist.extend( completo( item ) )

    return itemlist

def findvideos( item ):
    logger.info( "pelisalacarta.channels.cinehanwer findvideos" )

    itemlist = []

    # Descarga la pagina
    data = agrupa_datos( scrapertools.cache_page( item.url ) )

    # Extrae las entradas (carpetas)  
    patron  = '<tr[^<]+'
    patron += '<td[^<]+<div[^<]+'
    patron += '<img[^<]+'
    patron += '<a href="([^"]+)"[^<]+</a></td[^<]+'
    patron += '<td[^<]+<img src="([^"]+)"</td[^<]+'
    patron += '<td[^<]+<img[^>]+>([^<]+)</td[^<]+'
    patron += '<td[^>]+>([^<]+)</td[^<]+'
    patron += '<td[^<]+</td[^<]+'
    patron += '<td[^<]+'
    patron += '<a title="Reportar este enlace"'
    matches = re.compile( patron, re.DOTALL ).findall( data )

    for scrapedurl, serverthumb, idioma, calidad in matches:
        nombre_servidor = serverthumb.split( "/" )[-1]
        title = "Ver en " + nombre_servidor + " (" + idioma + ") (Calidad " + calidad + ")"
        url = scrapedurl
        thumbnail = ""
        plot = ""

        itemlist.append( Item( channel=__channel__, action="play", title=title, url=url, thumbnail=thumbnail, plot=plot, folder=False ) )

    return itemlist

def play( item ):
    logger.info( "pelisalacarta.channels.cinehanwer play url=" + item.url )

    itemlist = servertools.find_video_items( data=item.url )

    for videoitem in itemlist:
        videoitem.title = item.title
        videoitem.fulltitle = item.fulltitle
        videoitem.thumbnail = item.thumbnail
        videoitem.channel = __channel__

    return itemlist

## --------------------------------------------------------------------------------
## --------------------------------------------------------------------------------

## Agrupa los items de una función con paginación.
## item.extra debe contener en nombre de la función con
## paginación de la que se quiere agrupar los items.
def completo( item ):
    logger.info( "pelisalacarta.channels.cinehanwer completo" )

    itemlist = []

    ## Carga la primera página de items de la función contenida en item.extra
    exec "items_programas = " + item.extra + "( item )"
    if len( items_programas ) == 0: return []

    salir = False
    while not salir:

        ## Saca la URL de la siguiente página
        ultimo_item = items_programas[ len( items_programas )-1 ]

        ## Páginas intermedias
        if ultimo_item.action == item.extra:
            ## Quita el elemento de "Página siguiente" 
            ultimo_item = items_programas.pop()

            ## Añade los items de la página a la lista completa
            itemlist.extend( items_programas )
    
            ## Carga la sigiuente página
            exec "items_programas = " + item.extra + "( ultimo_item )"

        ## Última página
        else:
            ## Añade a la lista completa la última página y sale
            itemlist.extend( items_programas )
            salir = True

    return itemlist

## Agrupa los datos
def agrupa_datos( data ):
    logger.info( "pelisalacarta.channels.cinehanwer agrupa_datos" )

    data = re.sub( r'\n|\r|\t|&nbsp;|<br>|<br/>|<br\s/>|<!--.*?-->', '', data )

    data = re.sub( r'\s+', ' ', data )

    data = re.sub( r'>\s<', '><', data )
    data = re.sub( r'>\s([^<]+)\s<', r'>\1<', data )

    data = re.sub( r'"\s"', '""', data )
    data = re.sub( r'"\s([^"]+)\s"', r'"\1"', data )

    data = re.sub( r"'\s'", "''", data )
    data = re.sub( r"'\s([^']+)\s'", r"'\1'", data )

    data = unicode( data, 'iso-8859-1', errors='replace' ).encode( 'utf-8' )

    data = scrapertools.decodeHtmlentities( data )

    return data

## --------------------------------------------------------------------------------
## --------------------------------------------------------------------------------
